unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Print1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Characters1: TMenuItem;
    normal1: TMenuItem;
    condensed1: TMenuItem;
    Memo2: TMemo;
    TEST1: TMenuItem;
    N11: TMenuItem;
    N21: TMenuItem;
    polish1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure condensed1Click(Sender: TObject);
    procedure normal1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure polish1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  drukarka: textfile;
  condensed: boolean;
  col_nr, col_cn, row_nr, row_cn, pix_pc: integer;

implementation

uses Unit2;

{$R *.DFM}

procedure TForm1.Open1Click(Sender: TObject);
begin
     if (OpenDialog1.Execute) then begin
          Memo1.Lines.LoadFromFile(OpenDialog1.FileName);
     end;
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
     if (SaveDialog1.Execute) then begin
          Memo1.Lines.SaveToFile(SaveDialog1.FileName);
     end;
end;

procedure TForm1.Print1Click(Sender: TObject);
          var
             i,j,k, licznik: integer;
             linia, linia_ascii, linia_pl: string;
             literki, czyste, ogonki: string;
             a: char;
             sa_polskie: boolean;
begin
     literki:='󹜳ӥ';
     czyste:= 'eoaslzzcnEOASLZZCN';
     ogonki:= ',`,`/~```,`,^--^^`';

  assignfile(drukarka,'lpt1');
  rewrite (drukarka);
  licznik:=0;
  for i:=0 to (Memo1.Lines.Count-1) do begin
      linia:=Memo1.Lines[i];
      linia_ascii:=linia;
      linia_pl:=linia;
      sa_polskie:=false;
      for j:=1 to length(linia) do begin
          a:=linia[j];
          linia_pl[j]:=' ';
          for k:=1 to length(literki) do begin
              if (a=literki[k]) then begin
                  linia_ascii[j]:=czyste[k];
                  linia_pl[j]:=ogonki[k];
                  sa_polskie:=true;
              end;
          end;
      end;
      write (drukarka, linia_ascii);
      write (drukarka, chr(13));
      if (sa_polskie) then begin
         write (drukarka, linia_pl);
         write (drukarka, chr(13));
      end;
      write (drukarka, chr(10));
      inc(licznik);
      if (((condensed) and (licznik=row_cn)) or ((not(condensed)) and (licznik=row_nr))) then begin
         licznik:=0;
         write (drukarka, chr(12));
         if MessageDlg('Nastepna strona/ next page?',
    mtConfirmation, [mbYes, mbNo], 0) = mrNo then begin
                    closefile (drukarka);
                    exit;
    end;
      end;
  end;
  closefile(drukarka);
end;

procedure TForm1.condensed1Click(Sender: TObject);
begin
  assignfile(drukarka,'lpt1');
  rewrite (drukarka);
  write (drukarka, chr(15));
  closefile (drukarka);
  condensed:=true;
     Memo1.Width:=(col_cn+1)*pix_pc;
     Form1.Width:=Memo1.Width+20;
end;

procedure TForm1.normal1Click(Sender: TObject);
begin
  assignfile(drukarka,'lpt1');
  rewrite (drukarka);
  write (drukarka, chr(18));
  closefile (drukarka);
  condensed:=false;
     Memo1.Width:=(col_nr+1)*pix_pc;
     Form1.Width:=Memo1.Width+20;
end;

procedure TForm1.FormCreate(Sender: TObject);
          var
             i, a: integer;
             nazwa_zmiennej, zmienna: string;
begin
     try
         Memo2.Lines.LoadFromFile('drukarka.ini')
     except
         ShowMessage('Can not load drukarka.ini!');
         Application.Terminate;
     end;
     for i:=0 to (Memo2.Lines.Count-1) do begin
         if ((Memo2.Lines[i][1]<>'#') and (pos('=', Memo2.Lines[i])<>0)) then begin
            a:=pos('=', Memo2.Lines[i]);
            nazwa_zmiennej:=copy(Memo2.Lines[i],1,a-1);
            zmienna:=copy(Memo2.Lines[i],a+1,length(Memo2.Lines[i])-(a));
            if (nazwa_zmiennej='col_nr') then col_nr:=StrToInt(zmienna);
            if (nazwa_zmiennej='col_cn') then col_cn:=StrToInt(zmienna);
            if (nazwa_zmiennej='row_nr') then row_nr:=StrToInt(zmienna);
            if (nazwa_zmiennej='row_cn') then row_cn:=StrToInt(zmienna);
            if (nazwa_zmiennej='pix_pc') then pix_pc:=StrToInt(zmienna);
         end;
     end;
     Memo1.Width:=(col_nr+1)*pix_pc;
     Form1.Width:=Memo1.Width+20;
     condensed:=false;
end;

procedure TForm1.N11Click(Sender: TObject);
          var
             a: integer;
begin
  assignfile(drukarka,'lpt1');
  rewrite (drukarka);
  a:=StrToInt(InputBox('------TEST--------','wyslij kod/ send code','10'));
  write (drukarka, chr(a));
  closefile (drukarka);
end;

procedure TForm1.polish1Click(Sender: TObject);
begin
  assignfile(drukarka,'lpt1');
  rewrite (drukarka);
//start defining polish fonts  
  write (drukarka, chr(27));
  write (drukarka, chr(61));
  write (drukarka, chr(15));
  write (drukarka, chr(0));
  write (drukarka, chr(20));
  write (drukarka, chr(33));//zaczynam od znaku o kodzie 33
  write (drukarka, chr(0));
  write (drukarka, chr(0));
//data
  write (drukarka, chr(171));
  write (drukarka, chr(170));
  write (drukarka, chr(171));
  write (drukarka, chr(170));
  write (drukarka, chr(171));
  write (drukarka, chr(170));
  write (drukarka, chr(171));
  write (drukarka, chr(170));
  write (drukarka, chr(171));
  write (drukarka, chr(170));
  write (drukarka, chr(171));

  //TEST
  //print #33 ("!")
  write (drukarka, chr(33));
  //start using defined font
  write (drukarka, chr(27));
  write (drukarka, chr(73));
  write (drukarka, chr(4));
  //print #33
  write (drukarka, chr(33));
  write (drukarka, chr(33));
  write (drukarka, chr(33));
  //use old font again
  write (drukarka, chr(27));
  write (drukarka, chr(73));
  write (drukarka, chr(0));
  //print #33 ("!")
  write (drukarka, chr(33));
  write (drukarka, chr(10));

  closefile (drukarka);
end;

procedure TForm1.About1Click(Sender: TObject);
begin
 Form2.show;
end;

end.
